
var outputViewIds = [];

function searchOutputViewIds(jsonText) {
    outputViewIds = [];

    var data = JSON.parse(jsonText);
    parseViews(data);
    
    return outputViewIds;
}

function parseViews(view) {
    var writeClassType = view['writeClassType']
    
    if (writeClassType == "OriginalView" || writeClassType == "ViewControllerContentView") {
        outputViewIds.push({'id':view.originalId,'name':(view.className?view.className:'')});
    }else {
    }
    
    if (view.children) {
        for(var i=0; i<view.children.length; i++) {
            parseViews(view.children[i]);
        }
    }
}

var outputImagesInfo = [];
function searchImagesInfo(jsonText) {
    outputImagesInfo = [];
    
    var data = JSON.parse(jsonText);
    parseImages(data);
    
    return outputImagesInfo;
}

function parseImages(view) {
    var type = view['type']
    
    if (type == 'ImageView') {
        outputImagesInfo.push({'layerId':view.originalId,
                           'image':view['image']});
    }else {
    }
    
    if (view.children) {
        for(var i=0; i<view.children.length; i++) {
            parseImages(view.children[i]);
        }
    }
}



function contentsJsonString(png1x,png2x,png3x) {
    var json = {
        "images" : [
                    {
                    "idiom" : "universal",
                    "scale" : "1x",
                    },
                    {
                    "idiom" : "universal",
                    "scale" : "2x",
                    },
                    {
                    "idiom" : "universal",
                    "scale" : "3x"
                    }
                    ],
        "info" : {
            "version" : 1,
            "author" : "xcode"
        }
    };
    
    if (png1x && png1x.length>0) {
        json.images[0]["filename"] = png1x;
    }
    if (png2x && png2x.length>0) {
        json.images[1]["filename"] = png2x;
    }
    if (png3x && png3x.length>0) {
        json.images[2]["filename"] = png3x;
    }
    var str = JSON.stringify(json , null, "\t"); // Indented with tab
    return str;
}