

var startViewId = null;
var viewsWithIds = {};
var parentViewsWithIds = {};
var targetViews = [];
var importViews = [];
var isViewController = true;
var textPropertyViews = [];

function startWithViewId(jsonText,viewId,theIsViewController) {

  startViewId = viewId;
  isViewController = theIsViewController;
  viewsWithIds = {};
  parentViewsWithIds = {};
  targetViews = [];
  importViews = [];
  textPropertyViews = [];
  imagePropertyViews = [];

  var data = JSON.parse(jsonText);


  parseViews(data,false);



  return output();
}

if (module) {
  module.exports = startWithViewId;
}

function parseViews(view,isInTarget) {

  if (view.originalId == startViewId) {
    isInTarget = true
  }
  if (isInTarget) {
    targetViews.push(view);

      if (view.type == 'Label' && !isViewController && view.originalId != startViewId) {
          textPropertyViews.push(view);
      }

      if (view.type == 'ImageView' && !isViewController && view.originalId != startViewId) {
        imagePropertyViews.push(view);
      }

  }

  if (view.children) {
    for(var i=0; i<view.children.length; i++) {
      var child = view.children[i]
      parentViewsWithIds[child.originalId] = view;
      viewsWithIds[child.originalId] = child;

      if (child.writeClassType && child.writeClassType == 'OriginalView') {
        if (isInTarget) {
          targetViews.push(child);
          importViews.push(child);
        }
        parseViews(view.children[i],false);
      }else {
        parseViews(view.children[i],isInTarget);
      }
    }
  }
}

/////

function output() {
  var out = []
  var startView = viewsWithIds[startViewId];

  out.push('#import <UIKit/UIKit.h>');
  out.push('');
  for(var i=0; i<importViews.length; i++) {
    out.push('@class '+ importViews[i].className + ';');
  }
  if (importViews.length>0) {
    out.push('');
  }

  if (isViewController) {
    out.push('@interface MyViewController : UIViewController');
  }else {
    out.push('IB_DESIGNABLE');
    out.push('@interface '+startView.className+' : UIView');
  }
  out.push('');

  for(var i=(isViewController?0:1); i<targetViews.length; i++) {
    var view = targetViews[i];

    if (view.writeClassType && view.writeClassType == 'OriginalView') {
      out.push('@property (nonatomic, strong) ' +view.className+ ' *'+view.instance+';');

    } else if (view.writeClassType && view.writeClassType == 'ViewControllerContentView') {
      out.push('@property (nonatomic, strong) UIScrollView *scrollView;');
      out.push('@property (nonatomic, strong) UIView *'+view.instance+';');

    } else if (view.type == 'View') {
      out.push('@property (nonatomic, strong) UIView *'+view.instance+';');

    } else if (view.type == 'ImageView') {
      out.push('@property (nonatomic, strong) UIImageView *'+view.instance+';');

    } else if (view.type == 'Button') {
      out.push('@property (nonatomic, strong) UIButton *'+view.instance+';');

    } else if (view.type == 'Label') {
      out.push('@property (nonatomic, strong) UILabel *'+view.instance+';');

    } else if (view.type == 'TextField') {
      out.push('@property (nonatomic, strong) UITextField *'+view.instance+';');

    } else if (view.type == 'TextView') {
      out.push('@property (nonatomic, strong) UITextView *'+view.instance+';');

    }
  }
  out.push('');
  for(var i=0; i<textPropertyViews.length; i++) {
      var view = textPropertyViews[i];

      var propertyName = view['textPropertyName']
      if (propertyName.length>0) {
        var setter = 'set' + (propertyName.substr(0,1)).toUpperCase() + propertyName.substr(1)+':';
        out.push('@property (nonatomic, setter='+setter+
        ') IBInspectable NSString *'+propertyName+';');
      }
  }

  for(var i=0; i<imagePropertyViews.length; i++) {
      var view = imagePropertyViews[i];

      var propertyName = view['imagePropertyName']
      if (propertyName.length>0) {
        var setter = 'set' + (propertyName.substr(0,1)).toUpperCase() + propertyName.substr(1)+':';
        out.push('@property (nonatomic, setter='+setter+
        ') IBInspectable UIImage *'+propertyName+';');
      }
  }
  
  if (textPropertyViews.length>0 || imagePropertyViews.length>0) {
    out.push('');
  }


  out.push('@end');
  out.push('');

  return out.join('\n');
}
