

var startViewId = null;
var viewsWithIds = {};
var parentViewsWithIds = {};
var targetViews = [];
var importViews = [];
var textPropertyViews = [];
var isViewController = true;

function startWithViewId(jsonText,viewId,theIsViewController) {

  startViewId = viewId;
  isViewController = theIsViewController;
  viewsWithIds = {};
  parentViewsWithIds = {};
  targetViews = [];
  importViews = [];
  textPropertyViews = [];
  imagePropertyViews = [];

  var data = JSON.parse(jsonText);


  parseViews(data,false);

  return output();
}

if (module) {
  module.exports = startWithViewId;
}

function parseViews(view,isInTarget) {

  if (view.originalId == startViewId) {
    isInTarget = true
  }
  if (isInTarget) {
    targetViews.push(view);

    if (view.type == 'Label' && !isViewController && view.originalId != startViewId) {
      textPropertyViews.push(view);
    }

    if (view.type == 'ImageView' && !isViewController && view.originalId != startViewId) {
      imagePropertyViews.push(view);
    }

  }

  if (view.children) {
    for(var i=0; i<view.children.length; i++) {
      var child = view.children[i]
      parentViewsWithIds[child.originalId] = view;
      viewsWithIds[child.originalId] = child;

      if (child.writeClassType && child.writeClassType == 'OriginalView') {
        if (isInTarget) {
          targetViews.push(child);
          importViews.push(child);
        }
        parseViews(view.children[i],false);
      }else {
        parseViews(view.children[i],isInTarget);
      }
    }
  }
}

/////

function nameOfSetter(propertyName) {
  if (propertyName.length>0) {
    return 'set' + (propertyName.substr(0,1)).toUpperCase() + propertyName.substr(1)+':';
  }
  return ''
}

function nameOfUpdate(propertyName) {
  if (propertyName.length>0) {
    return 'update' + (propertyName.substr(0,1)).toUpperCase() + propertyName.substr(1)+'';
  }
  return ''
}

function uiColor(color) {
  var colorName = color.name;
    
  if (colorName) {
    return "UIColor."+colorName+"()";
  }else {
      var colorR = Math.round(color.r*1000)/1000;
      var colorG = Math.round(color.g*1000)/1000;
      var colorB = Math.round(color.b*1000)/1000;
      var colorA = color.a;
    return "UIColor(red: "+colorR+", green: "+colorG+", blue: "+colorB+", alpha: "+colorA+")";
  }
}

function outputAttributeLines(out,dictonaryName,paragraphStyleName,view,indentString) {
  var attribute = view.attributedText.attribute;
  var lines = out;
  var paragraphStyle = attribute.paragraphStyle;
  var dictonaryValue = attribute.value;
  /*
  var paragraphStyleName = paragraphStyle ? paragraphStyle.instance : '';
  if (useFixedVarName) {
    paragraphStyleName = 'paragraphStyle';
  }
  */
  var alignment;
  if (view.textAlignment) {
    if (view.textAlignment == 'center') {
      alignment = 'NSTextAlignment.Center';
    }else if (view.textAlignment == 'right') {
      alignment = 'NSTextAlignment.Right';
    }
  }
  if (paragraphStyle || alignment) {
    lines.push(indentString+'let '+paragraphStyleName+' = NSMutableParagraphStyle()');
    if (paragraphStyle && paragraphStyle.lineHeight) {
      var lineHeight = paragraphStyle.lineHeight;
      lines.push(indentString+paragraphStyleName+'.minimumLineHeight = '+ lineHeight);
      lines.push(indentString+paragraphStyleName+'.maximumLineHeight = '+ lineHeight);
    }

    if (alignment) {
      lines.push(indentString+paragraphStyleName+'.alignment = ' + alignment);
    }
  }

  lines.push(indentString+'let '+dictonaryName+' = [');
  if (paragraphStyle) {
    lines.push(indentString+'\t'+'NSParagraphStyleAttributeName : ' + paragraphStyleName +',');
  }

  if (dictonaryValue) {
    var colorAttribute = dictonaryValue.NSForegroundColorAttributeName;
    var fontAttribute = dictonaryValue.NSFontAttributeName;
    var fontAttributeName = view.font.name;
    var fontAttributeSize = view.font.size;
    var kernAttribute = dictonaryValue.NSKernAttributeName;

    if (colorAttribute) {
      lines.push(indentString+'\t'+'NSForegroundColorAttributeName : '+
      uiColor(colorAttribute)+',');
    }
    if (fontAttributeName) {
      if (view.font.name == '_system') {
        var font = dictonaryValue["NSFontAttributeName"]
        //lines.append("NSFontAttributeName : UIFont(name:\""+font["name"].asString+"\", size:" + numStr(font["size"]) + ")!,");
        lines.push(indentString+'\t'+'NSFontAttributeName : UIFont.systemFontOfSize('+view.font.size+ '),');
      }else if (view.font.name == '_systemBold') {
          var font = dictonaryValue["NSFontAttributeName"]
          //lines.append("NSFontAttributeName : UIFont(name:\""+font["name"].asString+"\", size:" + numStr(font["size"]) + ")!,");
          lines.push(indentString+'\t'+'NSFontAttributeName : UIFont.boldSystemFontOfSize('+view.font.size+ '),');
      }else {
        lines.push(indentString+'\t'+'NSFontAttributeName : UIFont(name:"'+view.font.name+
        '" , size:'+view.font.size+ ')!,');
      }
    }
    if (kernAttribute) {
      lines.push(indentString+'\t'+'NSKernAttributeName : '+kernAttribute+ ',');
    }

  }
  lines.push(indentString+']');
}

function output() {
  var out = []
  var startView = viewsWithIds[startViewId];
  var startClass = startView.className ? startView.className:'MyViewController';

  var selfPrefix = "self.";
  var selfViewName = "self";
  var rootViewName = "self.view";
  var isLocalScope = true;

  out.push('import UIKit');

    /*
  out.push('#import "'+startClass+'.h"');
  for(var i=0; i<importViews.length; i++) {
    out.push('#import "'+importViews[i].className+'.h"');
  }
*/

  out.push('');
  if (isViewController) {
  }else {
  }
  out.push('');


  if (isViewController) {
    out.push('class MyViewController : UIViewController {');
      out.push('');

  }else {
      out.push('@IBDesignable');
      out.push('class '+startClass + ' : UIView {');
      out.push('');

  }

    for(var i=(isViewController?0:1); i<targetViews.length; i++) {
        var view = targetViews[i];

        if (view.writeClassType && view.writeClassType == 'OriginalView') {
            out.push('\t'+'lazy var '+view.instance+' : ' +view.className+ ' = ' +view.className+ '()');

        } else if (view.writeClassType && view.writeClassType == 'ViewControllerContentView') {
            out.push('\t'+'lazy var scrollView : UIScrollView = UIScrollView()');
            out.push('\t'+'lazy var '+view.instance+' : UIView = UIView()');

        } else if (view.type == 'View') {
            out.push('\t'+'lazy var '+view.instance+' : UIView = UIView()');

        } else if (view.type == 'ImageView') {
            out.push('\t'+'lazy var '+view.instance+' : UIImageView = UIImageView()');

        } else if (view.type == 'Button') {
            out.push('\t'+'lazy var '+view.instance+' : UIButton = UIButton.buttonWithType(UIButtonType.System) as UIButton');

        } else if (view.type == 'Label') {
            out.push('\t'+'lazy var '+view.instance+' : UILabel = UILabel()');

        } else if (view.type == 'TextField') {
            out.push('\t'+'lazy var '+view.instance+' : UITextFiled = UITextField()');

        } else if (view.type == 'TextView') {
            out.push('\t'+'lazy var '+view.instance+' : UITextView = UITextView()');

        }
    }
    out.push('');

    if (isViewController) {

        out.push('\t'+'override func viewDidLoad() {');
        out.push('\t\t'+'super.viewDidLoad()');
        out.push('\t\t'+'self.configureView()');
        out.push('\t'+'}');
        out.push('');
        out.push('\t'+'func configureView() {');
//        out.push('}');
        out.push('\t\t'+selfPrefix+'scrollView.frame = self.view.bounds');

        out.push('\t\t'+selfPrefix+'scrollView.autoresizingMask = [UIViewAutoresizing.FlexibleWidth, UIViewAutoresizing.FlexibleHeight]');
        out.push('\t\t'+rootViewName+'.addSubview(self.scrollView)');
        out.push('');

    }else {

        out.push('\t'+'required init?(coder aDecoder: NSCoder) {');
        out.push('\t\t'+'super.init(coder: aDecoder)');
        out.push('\t\t'+'self.commonInit()');
        out.push('\t'+'}');
        out.push('');

        out.push('\t'+'override init(frame: CGRect) {');
        out.push('\t\t'+'super.init(frame: frame)');
        out.push('\t\t'+'self.commonInit()');
        out.push('\t'+'}');
        out.push('');

//        out.push('\t'+'override init() {');
//        out.push('\t\t'+'super.init()');
//        out.push('\t'+'}');
        out.push('');

        out.push('\t'+'func commonInit() {');
        if (targetViews.length>0) {
            out.push('\t\t'+selfPrefix+'bounds = CGRectMake(0, 0, '+
                     targetViews[0].frame.width+', '+targetViews[0].frame.height+')');
            out.push('');
        }

    }

  for(var i=0; i<targetViews.length; i++) {
    var view = targetViews[i];
    var isViewControllerRoot = (i==0 && isViewController)?true:false
    var isOriginalViewRoot = (i==0 && !isViewController)?true:false
    var isOriginalViewInstance = (i>0 && view.writeClassType && view.writeClassType == 'OriginalView')?true:false

    var indent = '\t\t';
    var subject = isOriginalViewRoot? selfViewName : selfPrefix + view.instance;
    var left = indent + subject;

    if (isOriginalViewRoot || isOriginalViewInstance) {
      //out.push(left + ' = ' +view.className+ '()');

    } else if (isViewControllerRoot) {

//      out.push(left+'.frame = '+rootViewName+'.bounds');
        /*
      if (view['contentSize']) {
        out.push(left+'.contentSize = CGSizeMake('+subject+'.frame.size.width, '+
        view.contentSize.height+');');
      }
         */
      //out.push(left+'.backgroundColor = UIColor.lightGrayColor()');

        //out.push(left+'.frame = '+rootViewName+'.frame');

    } else if (view.type == 'View') {

//      out.push(left + ' = UIView()');

    } else if (view.type == 'ImageView') {

//      out.push(left + ' = UIImageView()');
      out.push(left + '.image = UIImage(named:"'+view.image+'")');
      //out.push(left + '.contentMode = UIViewContentMode.Center');

    } else if (view.type == 'Button') {

//      out.push(left + ' = UIButton.buttonWithType(UIButtonType.System) as UIButton');
/*
      if (view.backgroundImage) {
        out.push(indent+'['+subject+' setBackgroundImage:[UIImage imageNamed:@"' +
        view.backgroundImage+'"] forState:UIControlStateNormal];');
      }
      out.push(indent+'['+subject+' addTarget:self action:@selector('+view.instance+'Tapped:) '+
      'forControlEvents:UIControlEventTouchUpInside];');
*/
    } else if (view.type == 'Label') {

//      out.push(left + ' = UILabel()');
      if (view.lineCount && view.lineCount>1 ) {
        out.push(left + '.numberOfLines = 0');
      }

      // attribute
      var text = view.isNeedAttributed? view.attributedText.text : view.text;
      var textPart = 'NSLocalizedString("' + text +'", comment: "")';

      if (view.isNeedAttributed && view.isNeedAttributed == true) {
        if (!isViewController) {
          out.push(indent + selfPrefix + view.textPropertyName + ' = ' + textPart + ';');
        }else {
          var attribute = view.attributedText.attribute;
          var paragraphStyleName = attribute.paragraphStyle ? attribute.paragraphStyle.instance : '';

          outputAttributeLines(out, attribute.instance, paragraphStyleName, view,indent);
          out.push(left+'.attributedText = NSAttributedString(string: '+
          textPart+', attributes: ' + attribute.instance + ')');
        }
      }else {
        if (view.textAlignment) {
          if (view.textAlignment == 'center') {
            out.push(left+'.textAlignment = NSTextAlignment.Center');
          }else if (view.textAlignment == 'right') {
            out.push(left+'.textAlignment = NSTextAlignment.Right');
          }
        }
        if (view.textColor) {
          out.push(left + '.textColor = '+uiColor(view.textColor) +'');
        }
        if (view.font) {
          if (view.font.name == '_system') {
            out.push(left+'.font = UIFont.systemFontOfSize('+view.font.size+ ')');
          }else if (view.font.name == '_systemBold') {
            out.push(left+'.font = UIFont.boldSystemFontOfSize('+view.font.size+ ')');
          }else {
            out.push(left+'.font = UIFont(name: "'+view.font.name+ '", size: '+view.font.size + ')');
          }
        }
        if (!isViewController) {
            out.push(indent + selfPrefix + view.textPropertyName + ' = ' + textPart);
        }else {
            out.push(left + '.text = ' + textPart);
        }

//        out.push(left+'.text = '+textPart+';');
      }


    } else if (view.type == 'TextField') {

//      out.push(left + ' = UITextField()');

    } else if (view.type == 'TextView') {

//      out.push(left + ' = UITextView()');

    }

    // view decoration
    if (!isOriginalViewRoot) {

      if (view.alpha && view.alpha<1.0 ) {
        out.push(left+'.alpha = '+view.alpha+';');
      }
    }
    if ((isViewController && !isOriginalViewRoot)|| (!isViewController && !isOriginalViewRoot) ) {
      if (view.frame) {
        if (view.contentSize) {
          out.push(left+'.frame = CGRectMake(0, 0, '+view.contentSize.width+', '+view.contentSize.height+')');

          //out.push(left+'.frame = CGRectMake(0, 0, '+view.contentSize.width+', '+rootViewName+'.bounds.size.height)');
          //out.push(left+'.contentSize = CGSizeMake('+view.contentSize.width+', '+view.contentSize.height+')');
          out.push(left+'.autoresizingMask = [UIViewAutoresizing.FlexibleWidth , UIViewAutoresizing.FlexibleBottomMargin]');
        }else {
          out.push(left+'.frame = CGRectMake('+view.frame.x+', '+view.frame.y+', '+
          view.frame.width+', '+view.frame.height+')');
        }

        if (view.constraints) {

          var hFormat = '';
          if (!view.constraints.right) {
            hFormat = 'UIViewAutoresizing.FlexibleRightMargin';
          }else if (!view.constraints.width) {
            hFormat = 'UIViewAutoresizing.FlexibleWidth';
          }else if (!view.constraints.left) {
            hFormat = 'UIViewAutoresizing.FlexibleLeftMargin';
          }

          var vFormat = '';
          if (!view.constraints.bottom) {
            vFormat = 'UIViewAutoresizing.FlexibleBottomMargin';
          }else if (!view.constraints.height) {
            vFormat = 'UIViewAutoresizing.FlexibleHeight';
          }else if (!view.constraints.top) {
            vFormat = 'UIViewAutoresizing.FlexibleTopMargin';
          }
          out.push(left+'.autoresizingMask = ['+hFormat+', '+vFormat+']');
        }
      }
    }

    if (!isOriginalViewInstance) {
      if (view.borderColor) {
        out.push(left+'.layer.borderColor = '+uiColor(view.borderColor)+'.CGColor');
      }
      if (view.borderWidth) {
        out.push(left+'.layer.borderWidth = '+view.borderWidth);
      }
      if (view.cornerRadius) {
        out.push(left+'.layer.cornerRadius = '+view.cornerRadius);
      }
      if (!(typeof view.userInteractionEnabled === "undefined") && (view.userInteractionEnabled==false)) {
        out.push(left+'.userInteractionEnabled = false');
      }
      if (view.backgroundColor) {
        out.push(left+'.backgroundColor = '+ uiColor(view.backgroundColor) +'');
      }
      if (view.clipsToBounds) {
        out.push(left+'.clipsToBounds = true');
      }
    }

    // add subview

    var parentName = '';
    if (isViewController) {
      parentName = selfPrefix+parentViewsWithIds[view.originalId]['instance'];
      if (view.originalId == startViewId) {
        parentName = "self.scrollView"; //rootViewName;
      }

    }else {
      parentName = selfViewName;
      if (parentViewsWithIds[view.originalId] && startViewId!=parentViewsWithIds[view.originalId].originalId) {
        parentName = selfPrefix+parentViewsWithIds[view.originalId]['instance'];
      }

    }
    if (!isOriginalViewRoot) {
      out.push(indent +parentName+'.addSubview('+subject+')');
      out.push('');
    }

  }

  if (isViewController) {
    var rootName = viewsWithIds[startViewId].instance;

    //out.push('\t\t'+selfPrefix+rootName+'.contentSize = CGSizeMake('+selfPrefix+rootName+'.frame.size.width, '+selfPrefix+rootName+'.contentSize.height)');
    //out.push('\t\t'+selfPrefix+rootName+'.frame = CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)');
      out.push('\t\t'+selfPrefix+rootName+'.frame = CGRectMake(0, 0, self.view.bounds.size.width, '+selfPrefix+rootName+'.bounds.size.height)');
      out.push('\t\t'+selfPrefix+'scrollView.contentSize = '+selfPrefix+rootName+'.frame.size');

    out.push('\t}');
    out.push('');
  }else {
    out.push('\t}');
    out.push('');
  }

  if (textPropertyViews.length>0) {
    out.push('\t// MARK: - text properties');
    out.push('');
    for(var i=0; i<textPropertyViews.length; i++) {
      var view = textPropertyViews[i];
      var textPropertyName = view.textPropertyName;
      var name = view.instance;

      out.push('\t@IBInspectable var '+textPropertyName + ': String? {');
      out.push('\t\t'+'didSet {');
      if (view.isNeedAttributed && view.isNeedAttributed == true) {

        out.push('\t\t\t' + 'if (oldValue != ' + textPropertyName + ') {');
        out.push('\t\t\t\t' + 'self.'+nameOfUpdate(name)+'()');
        out.push('\t\t\t' + '}');
        out.push('\t\t}');
        out.push('\t}');
        out.push('');
        out.push('\tfunc ' + nameOfUpdate(name) + '() {');

        var attribute = view.attributedText.attribute;
        var paragraphStyleName = attribute.paragraphStyle ? attribute.paragraphStyle.instance : '';

        out.push('\t\t' + 'let text = ' + selfPrefix + textPropertyName + ' ?? ""');
        outputAttributeLines(out, "attribute", "paragraphStyle", view,indent);

        out.push('\t\t'+selfPrefix+name+'.attributedText = NSAttributedString(string: text, attributes: ' + 'attribute' + ')');
        out.push('\t}');
        //        footerLines = footerLines.concat( textSettingLines(view, name, 'text',  isNeedAttributed, '\t' , true) );
      } else {
        out.push('\t\t\t'+selfPrefix + name +'.text = '+textPropertyName+'');
        out.push('\t\t}');
        out.push('\t}');
      }
      out.push('');
    }

  }

  if (imagePropertyViews.length>0) {
    out.push('\t// MARK: - image properties');
    out.push('');
    for(var i=0; i<imagePropertyViews.length; i++) {
      var view = imagePropertyViews[i];
      var imagePropertyName = view.imagePropertyName;
      var name = view.instance;

      out.push('\t@IBInspectable var '+imagePropertyName + ': UIImage? {');
      out.push('\t\t'+'didSet {');
      out.push('\t\t\t'+selfPrefix + name +'.image = '+imagePropertyName+'');
      out.push('\t\t}');
      out.push('\t}');
      out.push('');
    }

  }

  out.push('}');
  out.push('');

  return out.join('\n');
}
