
function psdJsonFilter() {
//    var fs = require('fs');
    var data = JSON.parse(psdJsonText);

//    console.log(data);
    var json = filterJson(data);
//    console.log(JSON.stringify(json));
    return JSON.stringify(json);
}
function filterJson(data) {
  data.layers = filterLayers(data.layers,null);
  return data;
}

// textShape[0]の下にboundsができることがある。
// photoshopでtext入力中にControl(Caps)を押すと、領域を変更できる（文字サイズも変わる）
// text入力中にShift+Controlを押しながら、領域外を範囲選択すると選択範囲にtextレイヤーができる。このときtextShapeにboundsがつく（文字サイズ変わらない）->これはboxの位置がうまく取れない
// "char" : "box"になる？

function filterLayers(layers,parent) {
  if (!layers ) {
    return;
  }
  for (var i = layers.length-1;i>=0;i--) {
    var layer  =layers[i];

    if ("text" in layer) {
      var scaleXX = 1.0;
      var scaleYY = 1.0;
      var moveXX = 0.0;
      var moveYY = 0.0;
        
        var shapeScaleXX = 1.0;
        var shapeScaleYY = 1.0;
        var shapeMoveXX = 0.0;
        var shapeMoveYY = 0.0;
        var baseMoveX = 0.0;
        var baseMoveY = 0.0;
        
/*
 x' = t.x + t.xx * x + t.xy * y
 y' = t.y + t.yx * x + t.yy * y
 */
        
      if ("transform" in layer.text) {
        scaleXX *= layer.text.transform.xx;
        scaleYY *= layer.text.transform.yy;
          moveXX -= layer.text.transform.tx;
          moveYY -= layer.text.transform.ty;
      }
      if ("textShape" in layer.text) {
          if ("base" in layer.text.textShape[0]) {
              baseMoveX -= layer.text.textShape[0].base.horizontal;
              baseMoveY -= layer.text.textShape[0].base.vertical;
              //console.log("bounds changed@@!:"+layer.name);
          }
          
        if ("transform" in layer.text.textShape[0]) {
            // textShapeのtransfrom.yyはshapeのboundsに対して行うのかも？
          shapeScaleXX *= layer.text.textShape[0].transform.xx;
          shapeScaleYY *= layer.text.textShape[0].transform.yy;
            shapeMoveXX -= layer.text.textShape[0].transform.tx;
            shapeMoveYY -= layer.text.textShape[0].transform.ty;

        }
          
          if ("bounds" in layer.text.textShape[0]) {
//              shapeMoveXX -= layer.text.textShape[0].transform.tx;
              shapeMoveYY -= layer.text.textShape[0].bounds.top;
              
          }
          
      }
      //console.log("scaleXX,scaleYY:"+scaleXX+","+scaleYY);
        if ("textStyleRange" in layer.text) {
          //∂†console.log("text"+layer.name);
          for (var j=0;j<layer.text.textStyleRange.length;j++) {
            var textStyleRange = layer.text.textStyleRange[j];
//            var fontSize = textStyleRange.textStyle.size.value;
//              if (scaleXX!=1.0 || scaleYY !=1.0) {
            textStyleRange.textStyle.size *= scaleYY;
            textStyleRange.textStyle.size = Math.round(textStyleRange.textStyle.size);
            //console.log("size changed@@!:"+textStyleRange.textStyle.size.value);
//              }
              if (textStyleRange.textStyle.leading) {
                  textStyleRange.textStyle.leading *= scaleYY;
              }
          }
        }
        if ("bounds" in layer.text) {
// ***          layer.text.bounds.top.originValue = layer.text.bounds.top;
            layer.text.bounds.top += baseMoveX + shapeMoveXX;
//            layer.text.bounds.top.value *= scaleYY;
// ***          layer.text.bounds.bottom.originValue = layer.text.bounds.bottom;
            layer.text.bounds.bottom += baseMoveY + shapeMoveYY;
//            layer.text.bounds.bottom.value *= scaleYY;
            
//            layer.text.bounds.left.value += moveXX;
//          layer.text.bounds.left.value *= scaleXX;
//            layer.text.bounds.right.value += moveXX;
//          layer.text.bounds.right.value *= scaleXX;
        }
        if ("boundingBox" in layer.text) {
// ***          layer.text.boundingBox.bottom.originValue = layer.text.boundingBox.bottom;
            var bottom = (layer.text.boundingBox.bottom + baseMoveY + shapeMoveYY);// * scaleYY;
// ***            layer.text.boundingBox.bottom.originValue = layer.text.boundingBox.bottom;
          layer.text.boundingBox.bottom = Math.round(bottom);
// ***          layer.text.boundingBox.top.originValue = layer.text.boundingBox.top;
            layer.text.boundingBox.top += baseMoveY + shapeMoveYY;
//            layer.text.boundingBox.top.value *= scaleYY;
          layer.text.boundingBox.top -= bottom - layer.text.boundingBox.bottom;
            
//            layer.text.boundingBox.left.value += moveXX;
//          layer.text.boundingBox.left.value *= scaleXX;
//            layer.text.boundingBox.right.value += moveXX;
//          layer.text.boundingBox.right.value *= scaleXX;
        }
    }

    if (layer.layers) {
      filterLayers(layer.layers,layer);
    }
  }
  return layers;
}


